## kunde 1.2010.8.14

=== Makefile ===
#POPCONFIG=$(CURDIR)/config.dist
## override this

include config.dist
export OWNER
export GROUP
export POPHOME=/usr/pop
export POPCONFIG=/etc/pop.conf
export POP=/pop
#export DATAHOST DATABASE

# Locales haben beim Bauen von Paketen etc. nix zu suchen.
export LANG=C
export LC_CTYPE=C
export LC_ALL=C
export LC_CTYPE=C
export LC_NUMERIC=C
export LC_TIME=C
export LC_COLLATE=C
export LC_MONETARY=C
export LC_MESSAGES=C
export LC_PAPER=C
export LC_NAME=C
export LC_ADDRESS=C
export LC_TELEPHONE=C
export LC_MEASUREMENT=C
export LC_IDENTIFICATION=C

SHELL=/bin/bash -e -o pipefail

VERSION := $(shell dpkg-parsechangelog -ldebian/changelog | sed -ne 's/^Version: *//p')

ifeq (,$(findstring release,$(DEB_BUILD_OPTIONS)))
VERS := test
else
VERS := kunde
endif

cc-option = $(shell if $(CC) $(1) -S -o /dev/null -xc /dev/null \
             > /dev/null 2>&1; then echo "$(1)"; else echo "$(2)"; fi ;)

export CFLAGS:=-O2 -g -DPOPCONFIG=\"$(POPCONFIG)\" \
	$(call cc-option,-Wno-pointer-sign)
export LANG=C
export LC_CTYPE=C

PERLLIBS:="$(CURDIR)/dbperl:$(CURDIR)/lib:$(CURDIR)/rt/lib:$(CURDIR)/htdocs/trouble-ticket/lib"

SUBPYTHON:=dbpython
SUBDIRS=acct bin cgi-bin dbperl etc htdocs kunde lib qsu rt test tools $(SUBPYTHON)

####### db templates
## 'db' ist das alte Kompatibilitätsding -- nicht mehr benötigt

TOPDIR=.

#all install clean obj:: # erstes Target ist Default...
#	@echo Using config file $(POPCONFIG)
#
all install obj:: noris
	mkdir -p obj

all:: python-stamp

test-stamp: noris
	$(MAKE) all
	$(MAKE) -C rt all
	touch test-stamp

python-stamp: noris dbpython/*.py
ifneq ($(SUBPYTHON),)
	python dbpython/setup.py build --build-lib=debian/build
	$(MAKE) -C tools all_p
endif
	touch python-stamp

clean::
	rm -rf obj
	rm -f noris lib/noris test/noris test-stamp
	rm -rf build

noris:
ifneq ($(SUBPYTHON),)
	cd test; rm -f noris; ln -s ../dbpython noris
	cd lib; rm -f noris; ln -s ../dbpython noris
	rm -f noris; ln -s dbpython noris
endif

obj/varsubst: obj $(CONFIG) Makefile 
	@ rm -f obj/varsubst
	@ ( echo MAILDOM=$(REAL_MAILDOM); echo POPHOME=$(POPHOME); echo POPCONFIG=$(POPCONFIG); echo RPM_PACKAGE_VERSION=${VERS}; echo RPM_PACKAGE_RELEASE=${VERSION};  ) \
	  | perl -ne 'chomp; if(s/^([0-9_A-Z]+)=//) { $$_ = $$ENV{$$1} if defined $$ENV{$$1}; print "s'"'"'\\\@$${1}\\\@'"'"'$$_'"'"';\n" } ' >$@
	@echo "'obj/varsubst' created."; echo ""

man:
	$(MAKE) -C bin man
	$(MAKE) -C tools man
	$(MAKE) -C dbperl man
	$(MAKE) -C rt man

install:: obj/varsubst
	install -o $(OWNER) -g $(GROUP) -m  755 -d $(DESTDIR)$(POPHOME)
	install -o $(OWNER) -g $(GROUP) -m 1773 -d $(DESTDIR)$(POPHOME)/tmp
	install -o $(OWNER) -g $(GROUP) -m  755 -d $(DESTDIR)$(POPHOME)/doc
	install -o $(OWNER) -g $(GROUP) -m  755 -d $(DESTDIR)$(POPHOME)/bin
	install -o $(OWNER) -g $(GROUP) -m  755 -d $(DESTDIR)$(POPHOME)/lib
	install -o $(OWNER) -g $(GROUP) -m  755 -d $(DESTDIR)$(POPHOME)/acct
	install -o $(OWNER) -g $(GROUP) -m  755 -d $(DESTDIR)$(POPHOME)/include
	install -o $(OWNER) -g $(GROUP) -m  770 -d $(DESTDIR)$(CACHEDIR)
	install -o $(OWNER) -g $(GROUP) -m  770 -d $(DESTDIR)$(LOGDIR)
	install -o $(OWNER) -g $(GROUP) -m  644 POP-Datenbank $(DESTDIR)$(POPHOME)
	echo ${VERSION} > $(DESTDIR)$(POPHOME)/VERSION
ifneq ($(SUBPYTHON),)
	$(MAKE) -C tools install_p
endif

all install diff::
	for i in $(SUBDIRS) ; do $(MAKE) -e TOPDIR=$(TOPDIR)/$$i -C $$i $@ ; done

clean::
	for i in $(SUBDIRS) ; do $(MAKE) -e TOPDIR=$(TOPDIR)/$$i -C $$i $@ || true; done

install::
	install -o root -g $(GROUP) -m  755 -d $(DESTDIR)/etc/init.d
	fn=/tmp/inst.$$$$; \
	for i in $$(git ls-files init); do \
		perl -p obj/varsubst <$$i >$$fn; \
		install -o root -g root -m 755 $$fn $(DESTDIR)/etc/init.d/kunde.$$(basename $$i); done; \
	rm $$fn

#	if test ! -f $(DESTDIR)/$(POPCONFIG) ; then \
#		fn=/tmp/inst.$$$$; \
#			perl -p obj/varsubst <config.dist >$$fn; \
#			install -o $(OWNER) -g $(GROUP) -m 640 $$fn $(DESTDIR)$(POPCONFIG) ; \
#		rm $$fn; \
#	fi

install:: python-stamp
ifneq ($(SUBPYTHON),)
	$(MAKE) -C dbpython install
endif
	

diff::
	echo Index: $(TOPDIR)/config
	-diff -bu config $(POPHOME)/config
	echo Index: $(TOPDIR)/POP-Datenbank
	-diff -bu POP-Datenbank $(POPHOME)/doc/POP-Datenbank

# Nicht getestet werden:
# Db/*.pm, die brauchen alle Datenbankzugriff
# Web*.pm, die brauchen Apache-Module

T=--modified --others
qtest: obj/varsubst noris
	rm -f obj/kunde_funcs
	$(MAKE) -C kunde
	@ptmp=/tmp/x.$$$$.pl; \
	ok=/tmp/ok.$$$$ ; touch $$ok; \
	err=/tmp/err.$$$$ ; \
	if test -z "$$TESTS" ; then \
	( git ls-files $T lib/acct kunde | egrep '^[a-z][^/]*(/[a-z][^/]*)*$$' ; \
	  git ls-files $T acct rt htdocs bin cgi-bin tools | egrep '^[a-z][^/]*(/[a-z][^/]*)*$$' | \
		xargs grep -l '^#!/usr/bin/perl'; \
	  git ls-files $T test | grep  '/[0-9][0-9]_' ; \
	  git ls-files $T htdocs rt dbperl | grep '\.p[lm]$$' | egrep -v '/(Db/|Web)' ) \
	else echo "$$TESTS" | xargs -n1 echo ; echo "" >&2; echo "" >&2; fi | \
		grep -v 'Makefile$$' | uniq | while read a ; do \
			test -f $$a || git checkout -- $$a; \
			if perl -p obj/varsubst <$$a >$$ptmp; env TESTING=1 KUNDE_NO_PERLPATH=1 POPCONFIG=$(CURDIR)/config.dist KUNDE=$(CURDIR)/kunde \
	PERL5LIB="$(CURDIR)/dbperl:$(CURDIR)/lib:$(CURDIR)/rt/lib:$(CURDIR)/htdocs/trouble-ticket/lib" \
	perl -c -Mstrict -Mwarnings $$ptmp >$$err 2>&1 ; then \
				: ; \
			else \
				rm -f $$ok ; \
			fi; \
			if test $$(grep -v "syntax OK" $$err | wc -l) -ne 0 ; then \
				echo -n "$$a: " ; cat $$err; \
				echo ""; \
			fi; \
		done  2>&1 | if test -z "$$TESTS" ; then less; else cat; fi; \
	rm -f $$ptmp $$err; \
	if test -f $$ok; then rm -f $$ok; else exit 1; fi

TESTHOST ?= $(shell if netcat -z localhost 3306 ; then echo localhost; else echo dev.office.noris.de; fi)
export TESTHOST

test:
	$(MAKE) clean
	$(MAKE) test-stamp
	$(MAKE) T="--cached --others" qtest
	$(MAKE) _rtest
rtest:
	$(MAKE) clean
	$(MAKE) test-stamp
	$(MAKE) _rtest

rrtest:
	$(MAKE) -C test
	@(if test -z "$$TESTS" ; then git ls-files -c -o test | sed -ne 's,^test/\([0-9][0-9]\)_,obj/test/\1_,p' | sort ; else echo "$$TESTS" | xargs -n1 echo | sed -e 's,^,obj/,' ; fi ) | \
	env TESTING3=1 REAL_TEST=1 POPCONFIG=$(CURDIR)/config.dist \
	perl -I/usr/share/kunde/trouble-ticket/lib -Mstrict -Mwarnings -MTest::Harness \
			-e 'my @t; while(<>) {chomp; push(@t,$$_);} runtests(@t);'
sstest:
	$(MAKE) -C test
	@(if test -z "$$TESTS" ; then git ls-files -c -o test | sed -ne 's,^test/\([0-9][0-9]\)_,obj/test/\1_,p' | sort ; else echo "$$TESTS" | xargs -n1 echo | sed -e 's,^,obj/,' ; fi ) | \
	while read t ; do echo "*** $$t ***"; \
	env TESTING3=1 TESTING4=1 REAL_TEST=1 POPCONFIG=$(CURDIR)/config.dist \
	perl -I/usr/share/kunde/trouble-ticket/lib -w -Mstrict -Mwarnings $$t ; echo ""; done \
	2>&1 | less "+/not ok"

ddtest:
	$(MAKE) -C test
	@(if test -z "$$TESTS" ; then git ls-files -c -o test | sed -ne 's,^test/\([0-9][0-9]\)_,obj/test/\1_,p' | sort ; else echo "$$TESTS" | xargs -n1 echo | sed -e 's,^,obj/,' ; fi ) | \
	while read t ; do echo "*** $$t ***"; \
	env TESTING3=1 TESTING4=1 REAL_TEST=1 POPCONFIG=$(CURDIR)/config.dist \
	perl -d -w -I/usr/share/kunde/trouble-ticket/lib -Mstrict -Mwarnings $$t ; echo ""; done 

_rtest:
	@(if test -z "$$TESTS" ; then git ls-files -c -o test | egrep '^test/[0-9][^/]*$$' | sort ; else echo "$$TESTS" | xargs -n1 echo ; fi ) | \
	env KUNDE_NO_PERLPATH=1 POPCONFIG=$(CURDIR)/config.dist KUNDE=$(CURDIR)/kunde TESTING3=1 PERL5LIB="$(PERLLIBS)" \
	perl -w -Mstrict -Mwarnings -MTest::Harness \
			-e 'my @t; while(<>) {chomp; push(@t,$$_);} runtests(@t);'
stest:
	$(MAKE) clean
	$(MAKE) test-stamp

	@(if test -z "$$TESTS" ; then git ls-files -c -o test | egrep '^test/[0-9][^/]*$$' | sort ; else echo "$$TESTS" | xargs -n1 echo ; fi ) | \
	while read t ; do echo "*** $$t ***"; \
	env KUNDE_NO_PERLPATH=1 POPCONFIG=$(CURDIR)/config.dist KUNDE=$(CURDIR)/kunde TESTING3=1 TESTING4=1 PERL5LIB="$(PERLLIBS)" \
	perl -w -Mstrict -Mwarnings $$t ; echo ""; done \
	2>&1 | less "+/not ok"

dtest:
	$(MAKE) clean
	$(MAKE) test-stamp

	@(if test -z "$$TESTS" ; then git ls-files -c -o test | egrep '^test/[0-9][^/]*$$' | sort ; else echo "$$TESTS" | xargs -n1 echo ; fi ) | \
	while read t ; do echo "*** $$t ***"; \
	env KUNDE_NO_PERLPATH=1 POPCONFIG=$(CURDIR)/config.dist KUNDE=$(CURDIR)/kunde PERL5LIB="$(PERLLIBS)" \
	perl -d -w -Mstrict -Mwarnings $$t ; echo ""; done 
ttest:
	$(MAKE) clean
	$(MAKE) test-stamp

	@(if test -z "$$TESTS" ; then git ls-files -c -o test | egrep '^test/[0-9][^/]*$$' | sort ; else echo "$$TESTS" | xargs -n1 echo ; fi ) | \
	while read t ; do echo "*** $$t ***"; \
	env KUNDE_NO_PERLPATH=1 POPCONFIG=$(CURDIR)/config.dist KUNDE=$(CURDIR)/kunde PERL5LIB="$(PERLLIBS)" \
	strace -f -s 300 perl -Mstrict -Mwarnings $$t ; echo ""; done 2>&1 | less

ditest:
	sh qsu/diff_run

atest: qtest rtest ditest

.PHONY: atest ditest _rtest test rtest stest qtest dtest all all_p install install_p diff noris

=== acct/Makefile ===
POPHOME=/tmp
OWNER=nobody
GROUP=none
SHELL=/bin/bash -e -o pipefail

PROG=$(wildcard [a-z]*)

all clean:

install:
	fn=/tmp/inst.$$$$; \
	for i in $(PROG) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/acct/$$i ; \
	done; \
	rm -f $$fn

diff:
	-for i in $(PROG); do \
		echo Index: $(TOPDIR)/$$i ; \
		perl -p ../obj/varsubst <$$i | diff -bu - $(POPHOME)/acct/$$i; done

=== bin/Makefile ===

###
### Makefile für den Xlink-POP-Datenbankbetrieb oder was auch immer.
###

POPHOME=/tmp
OWNER=nobody
GROUP=none
SHELL=/bin/bash -e -o pipefail

CFLAGS=-O2

ALL= db.safe dbbuild dbdump dbrestore descr kunde \
	rddump rdrestore db.pl db.py konfig2db
	# dbcmd status ticket 

ALL2= vicat

all:
	ln -sf db.pl db

clean:
	rm -f db

V=$(shell cd ..; dpkg-parsechangelog | sed -ne 's/^Version:\s*//p')

man:
	mkdir -p $(DESTDIR)/usr/share/man/man1
	grep -l '^#!/usr/bin/perl' * | xargs grep -l ^=head | while read a ; do \
		iconv -f utf8 -t latin1 $$a | pod2man -c Kunde -s 1 -q "''" -r $V -v | gzip -9 > $(DESTDIR)/usr/share/man/man1/$$a.1.gz ; \
	done

install:
	fn=/tmp/inst.$$$$; \
	for i in $(ALL) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/bin/$$i ; \
	done; \
	rm -f $$fn
	install -o $(OWNER) -g $(GROUP) -m 755 $(ALL2) $(DESTDIR)$(POPHOME)/lib
	ln -sf db.pl $(DESTDIR)$(POPHOME)/bin/db

diff:
	-for i in $(ALL); do \
		echo Index: $(TOPDIR)/$$i ; \
		perl -p ../obj/varsubst <$$i | diff -bu - $(POPHOME)/bin/$$i; done
	-for i in $(ALL2); do \
		echo Index: $(TOPDIR)/$$i ; \
		perl -p ../obj/varsubst <$$i | diff -bu - $(POPHOME)/lib/$$i; done

=== cgi-bin/Makefile ===
POPHOME=/tmp
OWNER=nobody
GROUP=none
CGIBIN=/usr/lib/cgi-bin/
SHELL=/bin/bash -e -o pipefail

WHAT=	check_flag_by_kunde.id \
	create_domain \
	register_domain_auftragsnr \
	get_accounting_timestamp \
	get_email_by_user.name \
	get_hardware_by_kunde.id \
	get_ipassacct_by_kunde.id \
	get_kunde.id_by_user.name \
	get_kunden_by_user.name \
	get_radacct_by_kunde.id get_radacct_dienste_by_kunde.id \
	get_sicherungen_by_rack.name \
	get_ticket_content_by_id get_tickets_by_user.name \
	get_unterkunden_by_kunde.id \
	get_trouble_ticket get_trouble_tickets_by_kunde.id \
	printenv

all:
	# nix
clean:

install:
	install -o $(OWNER) -g $(GROUP) -m 755 -d $(DESTDIR)$(CGIBIN)
	fn=/tmp/inst.$$$$; \
	for i in $(WHAT) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(CGIBIN)/$$i ; \
	done; \
	rm -f $$fn

diff:
	for i in $(WHAT) ; do \
		echo Index: $(TOPDIR)/$$i; \
		perl -p ../obj/varsubst <$$i | diff -bu - $(CGIBIN)$$i || true ; \
	done

.PHONY: all install diff

=== dbperl/Makefile ===
POPHOME=/tmp ## override!
OWNER=nobody
GROUP=none
SHELL=/bin/bash -e -o pipefail

DBP=$(wildcard Dbase/*.pm Dbase/*/*.pm)
DBE=Cf.pm
DBA=$(filter-out ${DBE}, $(wildcard *.pm))
DBF=$(shell find noris Net HousingDB -name \*.pm)
DBM=$(wildcard MIME/*.pm)

V=$(shell cd ..; dpkg-parsechangelog | sed -ne 's/^Version:\s*//p')

man:
	mkdir -p $(DESTDIR)/usr/share/man/man3
	find * \( -name \*.pm -o -name \*.pod \) -print | xargs grep -l =head | while read a ; do \
		echo Erzeuge man-Page fuer $$a ...; iconv -f utf8 -t latin1 $$a | grep -v "^=encoding utf8" | pod2man -c Kunde -s 3 -q "''" -r $V -v | gzip -9 > $(DESTDIR)/usr/share/man/man3/$$(echo $$a | sed -e "s/\.p\(m\|od\)$$//" -e s,/,::,g).3.gz ; \
	done

all clean:

install:
	find . -type d -print | while read d ; do \
		install -o $(OWNER) -g $(GROUP) -m 755 -d $(DESTDIR)$(POPHOME)/lib/$$d; \
		done

	fn=/tmp/inst.$$$$; \
	for i in $(DBA) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/lib/$$i ; \
	done; \
	rm -f $$fn

	fn=/tmp/inst.$$$$; \
	for i in $(DBP) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/lib/$$i ; \
	done; \
	rm -f $$fn

	fn=/tmp/inst.$$$$; \
	for i in $(DBF) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/lib/$$i ; \
	done; \
	rm -f $$fn

	fn=/tmp/inst.$$$$; \
	for i in $(DBE) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/lib/$$i ; \
	done; \
	rm -f $$fn

	fn=/tmp/inst.$$$$; \
	for i in $(DBM) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/lib/$$i ; \
	done; \
	rm -f $$fn

diff:
	-for i in $(DBA) $(DBE) $(DBP) $(DBF) $(DBM); do \
		echo Index: $(TOPDIR)/$$i; \
		perl -p ../obj/varsubst <$$i | diff -bu - $(POPHOME)/lib/$$i; done

=== dbpython/Makefile ===
SHELL=/bin/bash -e -o pipefail

all:
	@echo Nothing to do.

install:
	install -o root -g root -m 755 -d $(DESTDIR)/usr/lib/site-python/noris
	install -o root -g root -m 644 *.py $(DESTDIR)/usr/lib/site-python/noris

clean:
	rm -f *.pyc

=== etc/Makefile ===
POPHOME=/tmp
OWNER=nobody
GROUP=none
ETCDIR=/etc
SHELL=/bin/bash -e -o pipefail

WHAT=	exim4/headers_otrs2rt exim4/headers_rt2otrs

all:
	# nix
clean:

install:
	find . -type d -print | while read d ; do \
		install -o $(OWNER) -g $(GROUP) -m 755 -d $(DESTDIR)$(ETCDIR)/$$d; \
		done

	install -o $(OWNER) -g $(GROUP) -m 755 -d $(DESTDIR)$(ETCDIR)
	fn=/tmp/inst.$$$$; \
	for i in $(WHAT) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(ETCDIR)/$$i ; \
	done; 
	rm -f $$fn

diff:
	for i in $(WHAT) ; do \
		echo Index: $(TOPDIR)/$$i; \
		perl -p ../obj/varsubst <$$i | diff -bu - $(ETCDIR)$$i || true ; \
	done

.PHONY: all install diff

=== kunde/Makefile ===

###
### Makefile für den Xlink-POP-Datenbankbetrieb oder was auch immer.
###

# 2001-09-23 smurf Änderungslog angelegt
# 2001-09-23 smurf Fixups für Bitkeeper

POPHOME=/tmp
OWNER=nobody
GROUP=none
SUBDIRS=
SHELL=/bin/bash -e -o pipefail

DIRS := $(shell find . -type d -name '[a-z]*' )

all:: ../obj/kunde_funcs kunde_funcs

kunde_funcs: ../obj/kunde_funcs
	ln -s $< $@

../obj/kunde_funcs: Makefile $(ALL)
	git ls-files -z | xargs -0r perl -e 'while(<>) { $$skip=1 if /^package /; next if $$skip; print if s/^(sub\s+\w+\s*(?:\([\$$\@\&\;\\\%]*\))?)[^\n;]*$$/$$1;/; } continue { $$skip=0 if eof;} ' > $@
	@echo "1;" >> $@

install::
	install -o $(OWNER) -g $(GROUP) -m 751 -d $(DESTDIR)$(POPHOME)/lib/kunde
	for i in $(DIRS); do install -o $(OWNER) -g $(GROUP) -m 751 -d $(DESTDIR)$(POPHOME)/lib/kunde/$$i; done
	fn=/tmp/inst.$$$$; \
	git ls-files | while read i ; do \
		perl -p ../obj/varsubst <"$$i" >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 644 $$fn $(DESTDIR)$(POPHOME)/lib/kunde/"$$i"; done; \
	rm -f $$fn
	install -o $(OWNER) -g $(GROUP) -m 644 ../obj/kunde_funcs $(DESTDIR)$(POPHOME)/lib/kunde/

#diff::
#	# do nothing 

diff::
	git ls-files | while read i ; do \
		echo Index: $(TOPDIR)/$$i; \
		diff -bu "$$i" "$(POPHOME)/lib/kunde/$$i"; done

newfiles::
	comm -13 <(ls -1 .) <(ls -1 ${POPHOME}/lib/kunde/)

getnewfiles::
	comm -13 <(ls -1 .) <(ls -1 ${POPHOME}/lib/kunde/) | while read a ; do cp -av ${POPHOME}/lib/kunde/$$a . ; done

clean::
	rm -f ../obj/kunde_funcs
	
#all install clean diff::
#	for i in $(SUBDIRS) ; do $(MAKE) -e -C $$i $@ ; done

=== lib/Makefile ===

###
### Makefile für den Library-Kram
###

POPHOME=/tmp
OWNER=nobody
GROUP=none
SHELL=/bin/bash -e -o pipefail

WHAT :=  pop_conf_sh

all:: 
	#nothing to do

clean::

install::
	install -o root -g root -m 755 -d $(DESTDIR)/lib

	fn=/tmp/inst.$$$$; \
	for i in $(WHAT) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/lib/$$i ; \
	done; \
	rm -f $$fn

	install -d $(DESTDIR)$(POPHOME)/lib/acct
	find acct -maxdepth 1 -type f -print | while read a ; do install -m 644 "$$a" $(DESTDIR)$(POPHOME)/lib/acct ; done

diff::
	for i in $(PUBHDR) ; do \
		echo Index: $(TOPDIR)/$$i; \
		diff -bu $$i /usr/include/$$i || true ; \
	done

=== tools/Makefile ===
POPHOME=/usr/pop
OWNER=nobody
GROUP=none
SHELL=/bin/bash -e -o pipefail

WHAT= \
	acctdiff \
	acct.postfaecher \
	arbeitszeit4tickets \
	arbeitszeit-acct \
	beantrage_domains_beim_partnergate \
	beendete_kunden \
	check.accounting_up-to-dateness \
	check.acct_mess_stellen \
	check_db_chars \
	check.delegation \
	check.dns-zones \
	check_domain_expiries_by_whois \
	check_domain_expiries.ch_li \
	check_leitungsenden \
	check_rtticket_freshness \
	check_rt-tickets \
	check_ticket_freshness \
	collect_rt-queue_stats \
	dbdiff dbdiffreport \
	dbping \
	db_seqnum \
	dbstatus \
	dbtree \
	delete_old_acct \
	denic_member_GET \
	diff.hardware \
	dispatch.win-sec-ssc \
	domainliste \
	domainlose_webspaces \
	export.personen4ldap \
	extract_networks_from_bgp-table \
	find_descr \
	finde_0 \
	finde_freie_de-domains \
	finde_kunden_mit_mehreren_volumentarifen \
	finde_personenassoziierungen_mit_fehlenden_attributen \
	find_missing_domains \
	find_overlaps \
	fnbatcher \
	geburtstage \
	geistertraffic \
	gen.ablauf \
	gen.adressplan \
	gen.assoz \
	gen.descr \
	gen.dhcpconf \
	gen.domain \
	gen.eximconf \
	gen.fdzliste \
	gen.hostlist \
	gen.hostlist4standorte \
	gen.ip \
	gen.kundedomains \
	gen.kundenliste \
	gen.kunden_ohne_tarife_ausser \
	gen.mailusers \
	gen.mess \
	gen.nagioscontactgroups \
	gen.nagioshostgroups \
	gen.nagiosservices4leitungen \
	gen.radius \
	gen.testrechnungsdiff \
	gen.user \
	gen.virtualhosts \
	gen.vmps \
	gen.wan-monatsreport.fdz \
	gen.wice_liste \
	get_backup_volume \
	get.domainkosten \
	get_domainlist_from_partnergate \
	get_domainlist_from_switch \
	get_tickets \
	get.umsatz4kunde \
	hardwareliste \
	hotline-einsaetze \
	hotline-statistik \
	idndig \
	import_mess_system \
	ipacct \
	ipcalc \
	iplog \
	kunden_nach_vertrieblichen_ansprechpartnern \
	logserver \
	lohnbuchen2 \
	look4rt-tickets \
	maile.neue_hardware \
	maile.rt-billing2ap \
	maile.stunden \
	makedomains \
	manage.mysql-databases \
	mda.dsl-tt \
	messwert_ablesung \
	mig.2dienst \
	mig.ablauf \
	mig.hotline-stunden-arten \
	mig.partnergate-auftragsnr \
	mig.strings \
	mig.testsystem \
	mig.update_stunden \
	nsset \
	obsolete_FQDNs \
	print-all \
	pruefe_ustids \
	rech \
	remind_hardware_standorte \
	remind_pending_tts \
	rewrite_header \
	rt-eskalation \
	set_ds_keyword \
	show_domains \
	sshpipe \
	stunden-statistik \
	suche_reminder-ticket \
	ticketgen \
	tickets \
	trans.kunde \
	ueberpruefe_mailrules \
	ueberstunden \
	umsatzliste \
	umsatzplanung \
	update.domains.partnergate \
	urlaubsstand \
	wakeup \
	wice2pop.kprios \
	zeitstatistik \

override CFLAGS := $(CFLAGS) -Wall -D_GNU_SOURCE
LDLIBS=-L../obj -L$(POPHOME)/lib -Wl,-rpath,$(POPHOME)/lib 

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_SYSTEM ?= $(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM)

ifeq ($(DEB_HOST_ARCH),i386)
OBINS=../obj/ripe2cidr64 ../obj/logsplit64
build_64_target = x86_64-$(DEB_HOST_GNU_SYSTEM)
endif
ifeq ($(DEB_HOST_ARCH),amd64)
OBINS=../obj/ripe2cidr32 ../obj/logsplit32
build_32_target = i486-$(DEB_HOST_GNU_SYSTEM)
endif

all:  ../obj/ripe2cidr ../obj/logsplit $(OBINS)
all_p: ../obj/sql_diff

V=$(shell cd ..; dpkg-parsechangelog | sed -ne 's/^Version:\s*//p')

man:
	mkdir -p $(DESTDIR)/usr/share/man/man1
	grep -l '^#!/usr/bin/perl' * | xargs grep -l ^=head | while read a ; do \
		iconv -f utf8 -t latin1 $$a | pod2man -c Kunde -s 1 -q "''" -r $V -v | gzip -9 > $(DESTDIR)/usr/share/man/man1/$$a.1.gz ; \
	done

clean:
	rm -f ../obj/ripe2cidr ../obj/logsplit ../obj/*.o

../obj/logsplit: ../obj/logsplit.o
	$(CC) -g -o $@ $(filter-out %.a %.so,$^) $(LDLIBS)

../obj/ripe2cidr: ../obj/ripe2cidr.o
	$(CC) -g -o $@ $(filter-out %.a %.so,$^)

../obj/logsplit64: ../obj/logsplit64.o
	$(CC) -m64 -g -o $@ $(filter-out %.a %.so,$^) $(LDLIBS)

../obj/ripe2cidr64: ../obj/ripe2cidr64.o
	$(CC) -m64 -g -o $@ $(filter-out %.a %.so,$^)

../obj/logsplit32: ../obj/logsplit32.o
	$(CC) -m32 -g -o $@ $(filter-out %.a %.so,$^) $(LDLIBS)

../obj/ripe2cidr32: ../obj/ripe2cidr32.o
	$(CC) -m32 -g -o $@ $(filter-out %.a %.so,$^)

../obj/%.o: %.c
	$(CC) $(CFLAGS) -c -o $@ $^

../obj/%32.o: %.c
	$(CC) -m32 $(CFLAGS) -c -o $@ $^

../obj/%64.o: %.c
	$(CC) -m64 $(CFLAGS) -c -o $@ $^

../obj/sql_diff: sql_diff.g
	yapps $^ $@ || cp sql_diff.not $@
	chmod +x $@

install:
	install -o $(OWNER) -g $(GROUP) -m 755 -d $(DESTDIR)$(POPHOME)/bin
	install -o $(OWNER) -g $(GROUP) -m 755 -d $(DESTDIR)$(POPHOME)/lib
	install -o $(OWNER) -g $(GROUP) -m 755 ../obj/ripe2cidr $(DESTDIR)$(POPHOME)/bin
	install -o $(OWNER) -g $(GROUP) -m 755 ../obj/logsplit $(DESTDIR)$(POPHOME)/bin
ifneq ($(OBINS),)
	install -o $(OWNER) -g $(GROUP) -m 755 $(OBINS) $(DESTDIR)$(POPHOME)/bin
endif
	install -o root -g root -m 755 -d $(DESTDIR)/usr/sbin
	install -o root -g root -m 755 -d $(DESTDIR)/usr/bin

	fn=/tmp/inst.$$$$; \
	for i in $(WHAT) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/bin/$$i ; \
	done; \
	perl -p ../obj/varsubst <logclient >$$fn; \
	install -o root -g root -m 755 $$fn $(DESTDIR)/usr/sbin/logclient; \
	rm -f $$fn

install_p: all_p
	install -o root -g root -m 755 -d $(DESTDIR)/usr/bin
	install -o root -g root -m 755 ../obj/sql_diff $(DESTDIR)$(POPHOME)/bin

diff:
	for i in $(WHAT) ; do \
		echo Index: $(TOPDIR)/$$i; \
		perl -p ../obj/varsubst <$$i | diff -bu - $(POPHOME)/bin/$$i || true ; \
	done

.PHONY: all all_p install install_p diff

=== debian/changelog ===
kunde (1.2010.8.14) lenny; urgency=low

  * #10136528: check_rt-tickets: Selektion von Typen mit Wildcards ermöglicht;
    Möglichkeiten zur Selektion von Queue inkl. Unter-Queues dokumentiert;
    POD zur nicht mehr existenten Option -limit entfernt

 -- Martin H. Sluka <fany@noris.net>  Thu, 16 Sep 2010 15:06:38 +0200

kunde (1.2010.8.13) lenny; urgency=low

  * #10165401: bei artikelspezifischer Zeiterfassung Ticket-Titel einblenden
  * #10134564: Links auf Tickets in Zeiterfassung im selben Fenster öffnen
  * #10136515: Warnung wenn Person mit Rolle rtweb assoziiert wird

 -- Stelios Gikas <stelios.gikas@noris.net>  Thu, 16 Sep 2010 11:43:05 +0200

kunde (1.2010.8.12) lenny; urgency=low

  * Neue Version...

 -- Stelios Gikas <stelios.gikas@noris.net>  Wed, 15 Sep 2010 16:15:45 +0200

kunde (1.2010.8.11) lenny; urgency=low

  * #10181603: test/70_accounting: korrigiert zeit-pppoe eingefügt
  * #10120675: kunde_builder sendet mails direkt in Queue entwicklung::kunde
  * #10136515: Warnung wenn Person mit Rolle rtweb assoziiert wird
  * #10141393: NEU:arbeitszeit4tickets: zurückgebaut,
    dafür NEU:tickets: siehe [[Kunde/Tool "tickets"]]
  * #10171309: db.rechlauf funktioniert nicht
  * #10119873: Radius Ascus DSL - Acct Daten
  * #10176258: TT-Generator: Liste aller IGZ-Kunden
  * #10173448: tickets: Syntax für Sub-Queues dokumentiert
  * #10141393: tickets: Bugfix für SLA-Zeiten der "-gruppe incidents"
  * #10173770: suche_reminder-ticket: Anpassung auf neue billing-Queues im OTRS
  * #10102406: acct/do.stromaccounting verbessert

 -- Stelios Gikas <stelios.gikas@noris.net>  Wed, 15 Sep 2010 15:53:08 +0200

kunde (1.2010.8.8) lenny; urgency=low

  * #10155484: Kleiner Fehler bei Anzeige von IP-Zonen in kunde

 -- Stelios Gikas <stelios.gikas@noris.net>  Wed, 08 Sep 2010 17:19:51 +0200

kunde (1.2010.8.7) lenny; urgency=low

  * #10155455: für QSU-Tests OTRS-Backend (statt RT-Backend) verwenden,
    dabei als User "monitor" arbeiten
  * #10155455: NEU:arbeitszeit4tickets: wegen Backend-Umstellung (s. o.)

 -- Martin H. Sluka <fany@noris.net>  Wed, 08 Sep 2010 15:08:21 +0200

kunde (1.2010.8.6) lenny; urgency=low

  * #10152081: dispatch.win-sec-ssc für OTRS angepasst
  * #10154364: @rt.noris.net-Adressen aus Tools domainlose_webspaces
    und maile.neue_hardware beseitigt
  * #10155455: gen.oxconf auch aus qsu/tests entfernt

 -- Martin H. Sluka <fany@noris.net>  Wed, 08 Sep 2010 14:45:44 +0200

kunde (1.2010.8.5) lenny; urgency=low

  * Neue Version...

 -- Stelios Gikas <stelios.gikas@noris.net>  Tue, 07 Sep 2010 17:21:21 +0200

kunde (1.2010.8.4) lenny; urgency=low

  * Neue Version...

 -- Stelios Gikas <stelios.gikas@noris.net>  Mon, 06 Sep 2010 17:43:05 +0200

kunde (1.2010.8.3) lenny; urgency=low

  * Neue Version...

 -- Stelios Gikas <stelios.gikas@noris.net>  Mon, 06 Sep 2010 17:42:13 +0200

kunde (1.2010.8.2) lenny; urgency=low

  * #10130269: maile.rt-billing2ap: Kundenname am Anfang statt Ende des
    Subjects
  * #10132106: kunde: Suche von Hardware nach Eigentümer ermöglicht
  * #10132542: TT-Generator: Auswahlmöglichkeit für rtweb-Kunden
  * #10136238: Bei Domains mit DNS-Zone kann man sich mit "bz" nun
    anzeigen lassen, welcher Eintrag von wann und wem stammt.
  * #10125117: Anpassung noris::CreateTicket für OTRS-Ticketserver
  * #10141393: weitere Anpassung arbeitszeit4tickets für OTRS:
    + Spalten umbenannt:
      - "Area" in "Typ"
      - "Subject" in "Titel"
      - "Störungsflags" in "SLA-Relevanz"
    + zusätzliche Spalte "verantwortlich"
    + zusätzliche Option "-verantwortlich" zur Selektion
    + obsolete Warnung bei Option "-nur-sichtbare" entfernt
    + empfohlene Optionsnamen "-typ" und "-ohne-typ"
      (statt "-area" bzw. "-ohne-area")
  * #10121795: Trouble Tickets mit "Precedence: bulk" versenden
  * gen.oxconf gelöscht - wurde zuletzt 2009-06-22 verwendet
  * #10152081: dispatch.win-sec-ssc für OTRS angepasst

 -- Martin H. Sluka <fany@noris.net>  Mon, 06 Sep 2010 16:47:03 +0200

kunde (1.2010.8.1) lenny; urgency=low

  * Neue Version...

 -- Stelios Gikas <stelios.gikas@noris.net>  Mon, 26 Jul 2010 15:53:57 +0200

kunde (1.2010.8.0) lenny; urgency=low

  * #10125117: Anpassung noris::CreateTicket für OTRS-Ticketserver
  * #10126051: Strom Kunde Änderungen
  * #10126918: Warnung nach löschen von TSIG bei Domains
  * #10051870: Radius-Accounting für UMTS

 -- Stelios Gikas <stelios.gikas@noris.net>  Wed, 21 Jul 2010 15:17:11 +0200

kunde (1.2010.7.14) lenny; urgency=low

  [ Stelios Gikas ]
  * #10102406: check.acct_mess_stellen: Option -auch-ohne-mv hinzugefügt
  * #10124967: automagische Links aus Zeiterfassung
  * #10119873: Radius Ascus DSL - Acct Daten ':' -> '+'
  * #10127184: Trouble Tickets: Zeitzonenangabe bei "Ende nicht bekannt"
  * #10119873: Radius Daten (radacct.log Username bis '+' ignorieren)
  * #10129063: Cron <root@qsu5> /usr/pop/bin/./ablesung
  * #10129920: denic_member_GET: Anpassung auf aktuelle DENIC-Website
  * #615977: Infotext zu Leitungen wurde noch falsch als "kundeneigene
    Leitungsbezeichnung" bezeichnet; korrigiert
  * #10130416: look4rt-tickets: nur gesperrte Tickets beachten
  * #10131002: kunde: Beim Beenden einzelner IP-Adressen nicht im DNS
    nach Alteinträgen suchen, weil die in diesem Zusammenhang sowieso
    gelöscht werden.
  * #10131624: Bei Suche nach Mailregeln, die auf einen bestimmten User
    zeigen, nur solche beachten, die wirklich auf einen User zeigen
    (und nicht z. B. auf einen zufällig gleichnamigen Host).
  * #10133327: Dbase::OTRS: OTRS-Ticketnummern sind Strings!
  * #10130429: Dokumentation check_rt-tickets korrigiert
  * noris::CreateTicket: kein "noris." vor den Queue-Namen schreiben
  * #441274: RT: Hinweis, dass man das OTRS verwenden möchte
  * #10136137: Ticketgen Proxy
  * #10138218: Umlaute in via noris::CreateTicket eingelieferten Trouble Tickets
  * maile.rt-billing2ap soll nun an $TICKET_DOMAIN statt $RT_DOMAIN mailen



=== debian/control ===
Source: kunde
Section: noris/kunde
Priority: extra
Maintainer: Matthias Urlichs <smurf@noris.de>
Build-Depends: bash (>> 3), debhelper (>> 5), lib64c-dev [sparc s390 i386 powerpc], lib64gcc1 [i386 powerpc sparc s390], lib32c-dev [amd64 ppc64], lib32gcc1 [amd64 ppc64], gnupg, libalgorithm-diff-perl, libbusiness-tax-vat-validation-perl (>= 0.20-3), libcache-cache-perl, libchart-perl, libcompress-zlib-perl, libdata-dumpxml-perl, libdate-calc-perl, libdatetime-event-cron-perl, libdbd-mysql-perl, libdbi-perl, libemail-valid-perl, liberror-perl, libgnupg-perl, libhtml-tree-perl, libhtml-scrubber-perl, libhook-lexwrap-perl, libidna-punycode-perl, libio-pty-perl, libio-socket-ssl-perl, libio-string-perl, libipc-run3-perl, libjson-perl, libmail-box-perl, libmailtools-perl, libmime-perl, libmldbm-perl, libmoose-perl, libmysqlclient16-dev | libmysqlclient15-dev | libmysqlclient14-dev | libmysqlclient12-dev | libmysqlclient10-dev | libmysqlclient-dev, libnet-dns-perl, libnet-idn-punycode-perl, libnet-ip-perl, libnetaddr-ip-perl (>> 4), libnetsaint-noris-perl, libnoris-date-calendar-profiles-perl, libnumber-format-perl, libregexp-common-perl, librrds-perl, libscalar-list-utils-perl, libshlock-perl, libsocket6-perl, libstring-shellquote-perl, libtemplate-perl, libterm-readkey-perl, libterm-readline-gnu-perl, libtext-csv-xs-perl (>=0.52-1) | libtext-csv-perl (<< 1.06-1), libtext-wrapper-perl, libtie-ixhash-perl, libtime-modules-perl, libtime-period-perl, libtimedate-perl, liburi-find-perl, libwww-mechanize-perl, libxml-grove-perl, libxml-parser-perl, libyaml-perl, noris-csv-filter, perl (>= 5.6), perl-doc, perl-modules, oidentd | ident-server, python-dev, python-mysqldb, yapps2 (>> 2.1.1-16)
Standards-Version: 3.6.1

Package: kunde-common
Architecture: all
Pre-Depends: netbase (>= 4.21)
Depends: ${shlibs:Depends}, liberror-perl, libhtml-scrubber-perl, libmailtools-perl (<< 2.0) | libmailtools-perl (>= 2.05)
Conflicts: datenbank-extern, kunde-extern-dev
Replaces: kunde (<< 1.2007.4.13), kunde-htdocs (<< 1.2009.5)
Description: noris-kunde-Datenbank, Gemeinsames
 Kram für kunde und -python und -extern

Package: kunde-bin
Architecture: any
Pre-Depends: netbase (>= 4.21)
Depends: ${shlibs:Depends}
Replaces: kunde (<< 1.2008.9)
Description: noris-kunde-Datenbank, Binaries
 Kompilierte Programme

Package: kunde-32-bin
Architecture: any
Pre-Depends: netbase (>= 4.21)
Depends: libc6
Description: noris-kunde-Datenbank, Binaries
 Kompilierte Programme, 32bit

Package: kunde-64-bin
Architecture: any
Pre-Depends: netbase (>= 4.21)
Depends: libc6
Description: noris-kunde-Datenbank, Binaries
 Kompilierte Programme, 64bit

Package: kunde
Replaces: datenbank, kunde-snmp
Conflicts: datenbank, kunde-snmp
Architecture: all
Pre-Depends: kunde-common (= ${Source-Version})
Depends: ${shlibs:Depends}, kunde-bin (= ${Source-Version}), kunde-rt (= ${Source-Version}), libalgorithm-diff-perl, libbusiness-tax-vat-validation-perl (>= 0.20-3), libchart-perl, libcompress-zlib-perl, libdata-dump-perl, libdatetime-event-cron-perl, libdate-calc-perl, libdbd-mysql-perl, libdbi-perl, libemail-valid-perl, libgnupg-perl, libhook-lexwrap-perl, libidna-punycode-perl, libio-pty-perl, libio-socket-ssl-perl, libio-string-perl, libipc-run3-perl, libjson-perl, libmail-box-perl, libmailtools-perl, libmime-perl, libmldbm-perl, libmoose-perl, libnet-dns-perl, libnet-imap-simple-ssl-perl, libnet-idn-punycode-perl, libnet-ip-perl, libnetaddr-ip-perl (>> 4), libnoris-date-calendar-profiles-perl, libnumber-format-perl, libregexp-common-perl, libscalar-list-utils-perl, libshlock-perl, libsnmp-perl, libsocket6-perl, libstring-shellquote-perl, libtemplate-perl, libterm-readkey-perl, libterm-readline-gnu-perl, libtext-asciitable-perl, libtext-csv-xs-perl (>=0.52-1) | libtext-csv-perl (<< 1.06-1), libtext-wrapper-perl, libtie-ixhash-perl, libtime-modules-perl, libtime-period-perl, libtimedate-perl, libwww-mechanize-perl, libxml-grove-perl, libxml-parser-perl, libyaml-perl, noris-csv-filter, perl-doc, perl-modules, oidentd | ident-server, ucspi-tcp, shlock
Recommends: libgraphviz-perl, libnetsaint-noris-perl, librrds-perl
Suggests: libapache-mod-perl, kunde-doc, graphviz
Description: noris-kunde-Datenbank, intern
 Standard-Kram: kunde, /usr/pop/bin/*, ...

Package: kunde-extern
Architecture: all
Replaces: datenbank-extern
Conflicts: datenbank-extern
Pre-Depends: kunde-common (= ${Source-Version})
Depends: ${shlibs:Depends}, libcache-cache-perl, libdata-dumpxml-perl, libshlock-perl, libxml-parser-perl, libmime-perl
Recommends: libcrypt-ssleay-perl
Description: noris-kunde-Datenbank, extern
 Libraries zum externen Zugriff (via pam, etc.) auf die
 Kunden-Datenbank.

Package: kunde-python
Architecture: all
Pre-Depends: kunde-common (= ${Source-Version})
Depends: python (>= 2.3), ${python:Depends}, kunde (= ${Source-Version}), yapps2-runtime (>> 2.1.1-16), python-mysqldb
Replaces: kunde (<< 1.2007.1.6)
Description: noris-kunde-Datenbank, Python-Kram
 Python-Kram für kunde

Package: kunde-cgibin
Architecture: all
Depends: apache2 | apache, kunde (= ${Source-Version}), libcgi-untaint-perl, libcgi-untaint-hostname-perl, libcgi-untaint-ipaddress-perl, libdata-dumpxml-perl, perl (>= 5.8)
Description: noris-kunde-Datenbank, CGI-Scripts für REST-Backend
 Backend-Scripts für indirekte Datenbankabfragen etc., vgl. RT#214672

Package: kunde-rt
Architecture: all
Pre-Depends: kunde-common (= ${Source-Version})
Depends: ${perl:Depends}, kunde (= ${Source-Version}), libemail-valid-perl, libhtml-tree-perl, libhtml-scrubber-perl, libio-string-perl, libmail-box-perl, libmailtools-perl, libmime-perl, libnetsaint-noris-perl, librrds-perl, libtext-wrapper-perl, libtime-period-perl, liburi-perl, liburi-find-perl, perl-modules
Recommends: libapache-mod-perl, glimpse
Replaces: rt
Conflicts: rt
Description: RT für kunde
 RT-Webinterface für kunde

Package: kunde-doc
Architecture: all
Depends: kunde-common (= ${Source-Version})
Description: Doku für kunde
 Manpages für kunde-Programme

Package: kunde-htdocs
Architecture: all
Depends: kunde-common (= ${Source-Version}), kunde-rt (= ${Source-Version})
Replaces: kunde-cgibin (<< 1.2006.11.12)
Description: kunde-spezifische Dateien auf intra
 Stunden-Interface etc.

Package: kunde-qsu
Architecture: all
Depends: kunde-rt, git-core, dpkg-dev, diff, shlock
Description: kunde-spezifische Dateien auf qsu
 Scripts für die Qualitätssicherungskiste
 .
 Dieses Paket hängt explizit nicht von einer speziellen Version von
 kunde-common ab, damit es nicht automatisch mitgeupdatet wird.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatibility version to use.
export DH_COMPAT=4
SHELL=/bin/bash -e -o pipefail

TAGVERSION := $(shell dpkg-parsechangelog -ldebian/changelog | sed -ne 's/^Version: *//p' | sed -e 's/\./_/g')

# OWNER and GROUP
include config.dist

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	# NONE

	@if ! getent group $(GROUP) >/dev/null; then echo TODO: addgroup --system $(GROUP) ; exit 1; fi

	@if ! getent passwd $(OWNER) >/dev/null; then echo TODO: adduser --system --ingroup $(GROUP) --home /usr/pop $(OWNER) ; exit 1; fi

	touch configure-stamp

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(DEB_HOST_ARCH),i386)
kunde_xx_bin = kunde-64-bin
kunde_xx_arch = amd64
endif

ifeq ($(DEB_HOST_ARCH),amd64)
kunde_xx_bin = kunde-32-bin
kunde_xx_arch = i386
endif


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE) -f Makefile.Linux compile SUBPYTHON=dbpython
	#/usr/bin/docbook-to-man debian/datenbank.sgml > datenbank.1

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp python-stamp

	-$(MAKE) clean
	rm -rf debian/tmp

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	
	# install into debian/tmp
	$(MAKE) -f Makefile.Linux install DESTDIR=$(CURDIR)/debian/tmp SUBPYTHON=dbpython
	$(MAKE) man DESTDIR=$(CURDIR)/debian/tmp

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -n -i
	dh_installchangelogs  -i
	dh_link -i
	dh_strip -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_perl -i
	
	for p in kunde-doc kunde-cgibin kunde-extern kunde-python kunde-qsu kunde-htdocs ; do \
		dh_movefiles --package=$$p; \
		cd debian/$$p; mkdir -p var/cache; find . -user $(OWNER) -print0 > var/cache/pop.files.$$p; cd ../..; \
	done
	
	#install -d debian/kunde-python/usr/pop/bin
	#install -m 755 -o root -g root bin/db.py debian/kunde-python/usr/pop/bin/db
	#
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i


# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
#	dh_installdebconf	 -a
	dh_installdocs -n -a
	dh_installexamples -p kunde examples/*
#	dh_installmenu -a
#	dh_installlogrotate -a
#	dh_installemacsen -a
#	dh_installpam -a
#	dh_installmime -a
#	dh_installinit -a
#	dh_installcron -a
#	dh_installman -a
#	dh_installinfo -a
#	dh_undocumented -a
	dh_installchangelogs  -a
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
#	dh_makeshlibs -a
	dh_installdeb -a
	dh_perl -a

	# Some files are in more than one package
	for p in kunde-common $(kunde_xx_bin) kunde-bin kunde-rt kunde ; do \
		dh_movefiles --package=$$p ; \
		cd debian/$$p; mkdir -p var/cache; find . -user $(OWNER) -print0 > var/cache/pop.files.$$p; cd ../..; \
	done

	dh_shlibdeps -a
	dh_gencontrol -a
ifneq ($(kunde_xx_bin),)
	perl -pi -e 's/^(Package:\s+)$(kunde_xx_bin)/$${1}kunde-bin/; s/^(Architecture:\s+)$(DEB_HOST_ARCH)/$${1}$(kunde_xx_arch)/; s/^(Depends:.*\blibc)-$(kunde_xx_arch)\b/$${1}/' debian/$(kunde_xx_bin)/DEBIAN/control
	find debian/$(kunde_xx_bin) -type f | while read f ; do g="$$(echo $$f | sed -e 's/32$$//g' -e 's/64$$//g')"; [ "$$f" = "$$g" ] || mv "$$f" "$$g" ; done
endif
#Package: kunde-64-bin
#Version: 1.2008.8.12
#Section: noris/kunde
#Priority: extra
#Architecture: i386
#Pre-Depends: netbase (>= 4.21)
#Depends: libc6-amd64 (>= 2.3.5-1)
#Installed-Size: 168
#Maintainer: Matthias Urlichs <smurf@noris.de>
#Source: kunde
#Description: noris-kunde-Datenbank, Binaries

	dh_md5sums -a
	dh_builddeb kunde-bin $(kunde_xx_bin)
ifneq ($(kunde_xx_bin),)
	perl -pi -e 's/^$(kunde_xx_bin)_(.*)_$(DEB_HOST_ARCH)\.deb/kunde-bin_$${1}_$(kunde_xx_arch).deb/' debian/files
endif
#kunde-64-bin_1.2008.8.12_i386.deb noris/kunde extra

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

version:
	@echo ${TAGVERSION}
